 # Advent of Code - 2022
Copyright (c) Eric Wastl
#### [Direct Link](https://adventofcode.com/2022)

## Intro 

Santa's reindeer typically eat regular reindeer food, but they need a lot of [magical energy](https://adventofcode.com/2018/day/25) to deliver presents on Christmas. For that, their favorite snack is a special type of **star** fruit that only grows deep in the jungle. The Elves have brought you on their annual expedition to the grove where the fruit grows.

To supply enough magical energy, the expedition needs to retrieve a minimum of **fifty stars** by December 25th. Although the Elves assure you that the grove has plenty of fruit, you decide to grab any fruit you see along the way, just in case.

Collect stars by solving puzzles. Two puzzles will be made available on each day in the Advent calendar; the second puzzle is unlocked when you complete the first. Each puzzle grants **one star**. Good luck!


## Overview

| Day | Part 1 | Part 2 | My Solution | Official Website | 
| --- | --- | --- |---| --- |
| 01 | :white_check_mark: | :white_check_mark: | [Solution](01/code.py) | [Day 01](https://adventofcode.com/2022/day/1) |
| 02 | :white_check_mark: | :white_check_mark: | [Solution](02/code.py) | [Day 02](https://adventofcode.com/2022/day/2) |
| 03 | :white_check_mark: | :white_check_mark: | [Solution](03/code.py) | [Day 03](https://adventofcode.com/2022/day/3) |
| 04 | :white_check_mark: | :white_check_mark: | [Solution](04/code.py) | [Day 04](https://adventofcode.com/2022/day/4) |
| 05 | :white_check_mark: | :white_check_mark: | [Solution](05/code.py) | [Day 05](https://adventofcode.com/2022/day/5) |
| 06 | :white_check_mark: | :white_check_mark: | [Solution](06/code.py) | [Day 06](https://adventofcode.com/2022/day/6) |
| 07 | :white_check_mark: | :white_check_mark: | [Solution](07/code.py) | [Day 07](https://adventofcode.com/2022/day/7) |
| 08 | :white_check_mark: | :white_check_mark: | [Solution](08/code.py) | [Day 08](https://adventofcode.com/2022/day/8) |
| 09 | :white_check_mark: | :white_check_mark: | [Solution](09/code.py) | [Day 09](https://adventofcode.com/2022/day/9) |
| 10 | :white_check_mark: | :white_check_mark: | [Solution](10/code.py) | [Day 10](https://adventofcode.com/2022/day/10) |
| 11 |  |  |  | [Day 11](https://adventofcode.com/2022/day/11) |
| 12 |  |  |  | [Day 12](https://adventofcode.com/2022/day/12) |
| 13 |  |  |  | [Day 13](https://adventofcode.com/2022/day/13) |
| 14 |  |  |  | [Day 14](https://adventofcode.com/2022/day/14) |
| 15 |  |  |  | [Day 15](https://adventofcode.com/2022/day/15) |
| 16 |  |  |  | [Day 16](https://adventofcode.com/2022/day/16) |
| 17 |  |  |  | [Day 17](https://adventofcode.com/2022/day/17) |
| 18 |  |  |  | [Day 18](https://adventofcode.com/2022/day/18) |
| 19 |  |  |  | [Day 19](https://adventofcode.com/2022/day/19) |
| 20 |  |  |  | [Day 20](https://adventofcode.com/2022/day/20) |
| 21 |  |  |  | [Day 21](https://adventofcode.com/2022/day/21) |
| 22 |  |  |  | [Day 22](https://adventofcode.com/2022/day/22) |
| 23 |  |  |  | [Day 23](https://adventofcode.com/2022/day/23) |
| 24 |  |  |  | [Day 24](https://adventofcode.com/2022/day/24) |
| 25 |  |  |  | [Day 25](https://adventofcode.com/2022/day/25) |
